using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class SoundPlayer : MonoBehaviour {
	
	public AudioClip[] sounds;
	
	private AudioSource audiosource;
	private Level level;
	
	public enum SoundType {
		S_Player,
		S_Block,
		S_Whale,
	};
	
	private class SoundMessage {
		public SoundType soundtype;
		public float timeoffset;
		public SoundMessage (SoundType soundtype, float timeoffset)
		{
			this.soundtype = soundtype;
			this.timeoffset = timeoffset;
		}
	}
	
	private static List<SoundMessage> soundmessages = new List<SoundMessage>();
	
	private static List<List<SoundMessage>> soundmessagesbak = new List<List<SoundMessage>>();
	
	public static void PushStack()
	{
		soundmessagesbak.Add(new List<SoundMessage>(soundmessages));
	}
	
	public static void PopStack(bool reapply)
	{
		if (reapply)
		{			
			soundmessages = soundmessagesbak[soundmessagesbak.Count-1];
		}
		soundmessagesbak.RemoveAt(soundmessagesbak.Count-1);
	}
	
	public static void PlaySound(SoundType soundtype, float timeoffset)
	{
		SoundMessage sm = new SoundMessage(soundtype,timeoffset);
		soundmessages.Add(sm);
	}
	
	public void ClearSoundQueue()
	{
		soundmessages.Clear();
	}
	
	// Use this for initialization
	void Start () {
		audiosource = GetComponent<AudioSource>();
		level = GameObject.Find("Level").GetComponent<Level>();
	}
	
	private float t= 0;
	// Update is called once per frame
	void Update () {
		if (soundmessagesbak.Count>0)
		{
			Debug.LogError("SMC " + soundmessages.Count);
		}
		/*
		t+=Time.deltaTime;
		if (t>1)
		{
			t=0;
			audiosource.PlayOneShot(sounds[Random.Range(0,sounds.Length)]);
		}*/
		
		for (int i = soundmessages.Count-1;i>=0;i--)
		{
			SoundMessage sm = soundmessages[i];
			sm.timeoffset-=Time.deltaTime;
			if (sm.timeoffset<=0)
			{
				soundmessages.Remove(sm);
				audiosource.PlayOneShot(sounds[(int)sm.soundtype],0.1f);
			}
		}
	}
}
