using UnityEngine;
using System.Collections;

public class TitleScript : MonoBehaviour {
	
	private Color[] GameColors =
	{
		//0 background
		Color.black,
		//1 wall
		Color.black,
		//2 block
		Color.black,
		//3 whale
		Color.black,
		//4 player
		Color.black,
		//5 beam
		Color.black,
		//6 start
		Color.black,
		//7 end
		Color.black,
	};
	
	public GameObject newgametext;
	public GameObject continuetext;
	
	public float seasonlength = 20.0f;
	
	public float colorlerpspeed = 1.0f;
	public GameObject selectioncube;
	public AudioClip ac;
	
	void Blip()
	{
		GetComponent<AudioSource>().PlayOneShot(ac,0.1f);		
	}
	// Use this for initialization
	void Start () {	
		if (Application.isEditor==false)
		{			
			Screen.showCursor=false;
		}
		if (PlayerPrefs.HasKey("levelname")==false ||  PlayerPrefs.GetString("levelname")=="level13")
		{
			continuetext.active=false;
			newgametext.transform.position = (newgametext.transform.position+continuetext.transform.position)/2;
		}
		else
		{
			selection=1;
		}
	}
	
	public TextMesh tm;
	int selection=0;
	private bool done=false;
	// Update is called once per frame
	void Update () {
		if (done)
			return;
		
		if (Input.GetKeyDown(KeyCode.F))
		{
			Screen.fullScreen=!Screen.fullScreen;
		}
		
		if (Input.GetKeyDown(KeyCode.Escape))
		{
			Application.Quit();
		}
		
		if (Input.GetKeyDown(KeyCode.DownArrow))
		{
			if (PlayerPrefs.HasKey("levelname"))
			{
				selection = 1-selection;
				Blip();
			}
		}
		if (Input.GetKeyDown(KeyCode.UpArrow))
		{
			if (PlayerPrefs.HasKey("levelname"))
			{
				selection = 1-selection;
				Blip();
			}
		}
		
		if (Input.GetButtonDown("Action"))
		{
			if (selection==0)
			{
				PlayerPrefs.DeleteKey("levelname");
				Application.LoadLevelAsync("MainScene");
				done=true;
				Blip();
			}
			else
			{
				Application.LoadLevelAsync("MainScene");				
				done=true;
				Blip();
			}
		}
		
		int targetpal = 4 + ((int)(Time.time/seasonlength))%3;
		
		for (int i=0;i<GameColors.Length;i++)
		{
			Color targetcola = RenderLevel.Palettes[targetpal,i];
			Color targetcolb = RenderLevel.Palettes[4+((targetpal-4+1)%3),i];
			float progress = (Time.time/seasonlength)%1.0f;
			Color target = Color.Lerp(targetcola,targetcolb,progress);
			GameColors[i] = Color.Lerp(GameColors[i],target,Time.deltaTime*colorlerpspeed);
		}		
		
		camera.backgroundColor = GameColors[(int)RenderLevel.Pal.BG];
		tm.renderer.sharedMaterial.color = GameColors[(int)RenderLevel.Pal.Wall];
		selectioncube.renderer.material.color = GameColors[(int)RenderLevel.Pal.Beam];
		
		GameObject t = selection==0 ? newgametext : continuetext;
		selectioncube.transform.position = t.transform.position + Vector3.forward;// + Vector3.up*(2.489109f-2.407845f);
		
	}
}
